include("shared.lua")  
   
function ENT:Initialize( )	
    self:SetRenderBounds(Vector( -3000, -3000, -3000 ), Vector( 3000, 3000, 3000 ));
end  
   
function ENT:OnRemove( ) 

end  

local restartGMod = surface.GetTextureID("perp2/tv/restart_gmod");
local enableTVs = surface.GetTextureID("perp2/tv/enable_tvs");
local tvRT = GetRenderTarget("PERP25Screen512", 512, 256)

surface.CreateFont("Tahoma", 40, 1000, true, false, "TVLargeFont") 

local Scale = 0.0555;

local CLOUDS_CLEAR = 1;
local CLOUDS_PARTLY = 2;
local CLOUDS_MOSTLY_PRE = 3;
local CLOUDS_MOSTLY_POST = 4;
local CLOUDS_STORMY = 5;
local CLOUDS_STORMY_LIGHT = 6;
local CLOUDS_STORMY_PRE = 7;
local CLOUDS_STORMY_SEVERE = 8;
local CLOUDS_HEATWAVE = 9;

local weatherInformation = {}
weatherInformation[1] = {} // Normal Weather
weatherInformation[1][CLOUDS_HEATWAVE] = {surface.GetTextureID("perp2/tv/weather_sunny"), "Heatwave"}
weatherInformation[1][CLOUDS_CLEAR] = {weatherInformation[1][CLOUDS_HEATWAVE][1], "Clear Skies"}
weatherInformation[1][CLOUDS_PARTLY] = {surface.GetTextureID("perp2/tv/weather_partly_cloudy"), "Partly Cloudy"}
weatherInformation[1][CLOUDS_MOSTLY_PRE] = {surface.GetTextureID("perp2/tv/weather_cloudy"), "Mostly Cloudy"}
weatherInformation[1][CLOUDS_MOSTLY_POST] = {weatherInformation[1][CLOUDS_MOSTLY_PRE][1], "Mostly cloudy"}
weatherInformation[1][CLOUDS_STORMY] = {surface.GetTextureID("perp2/tv/weather_storming"), "Thunder Storms"}
weatherInformation[1][CLOUDS_STORMY_LIGHT] = {surface.GetTextureID("perp2/tv/weather_showers"), "Light Showers"}
weatherInformation[1][CLOUDS_STORMY_PRE] = {weatherInformation[1][CLOUDS_MOSTLY_PRE][1], "Mostly Cloudy"}
weatherInformation[1][CLOUDS_STORMY_SEVERE] = {weatherInformation[1][CLOUDS_STORMY][1], "Severe Thunder Storms"}

weatherInformation[2] = {} // Normal Weather
weatherInformation[2][CLOUDS_HEATWAVE] = {weatherInformation[1][CLOUDS_HEATWAVE][1], "Heatwave"}
weatherInformation[2][CLOUDS_CLEAR] = {weatherInformation[1][CLOUDS_HEATWAVE][1], "Clear Skies"}
weatherInformation[2][CLOUDS_PARTLY] = {weatherInformation[1][CLOUDS_PARTLY][1], "Partly Cloudy"}
weatherInformation[2][CLOUDS_MOSTLY_PRE] = {weatherInformation[1][CLOUDS_MOSTLY_PRE][1], "Mostly Cloudy"}
weatherInformation[2][CLOUDS_MOSTLY_POST] = {weatherInformation[1][CLOUDS_MOSTLY_PRE][1], "Mostly Cloudy"}
weatherInformation[2][CLOUDS_STORMY] = {surface.GetTextureID("perp2/tv/weather_blizzard"), "Heavy Snow"}
weatherInformation[2][CLOUDS_STORMY_LIGHT] = {surface.GetTextureID("perp2/tv/weather_snow_light"), "Light Snow"}
weatherInformation[2][CLOUDS_STORMY_PRE] = {weatherInformation[1][CLOUDS_MOSTLY_PRE][1], "Mostly Cloudy"}
weatherInformation[2][CLOUDS_STORMY_SEVERE] = {weatherInformation[2][CLOUDS_STORMY][1], "Blizzard Conditions"}

function ENT:Draw( ) 
	local Dist = LocalPlayer():GetPos():Distance(self:GetPos());
	
	if Dist <= 500 then
		LastSawTele = CurTime();
	elseif Dist <= 1500 then
		local Tr = {};
		Tr.start = LocalPlayer():EyePos();
		Tr.endpos = self:GetPos();
		Tr.filter = {LocalPlayer(), self};
		Tr.mask = MASK_OPAQUE;
		
		if LocalPlayer():InVehicle() then
			table.insert(Tr.filter, LocalPlayer():GetVehicle());
		end
		
		local TRes = util.TraceLine(Tr);
		
		if !TRes.Hit then
			LastSawTele = CurTime();
		end
	end
	
	self.Entity:DrawModel() 
   
	local obbmid = self:OBBCenter()
	local obbmin = self:OBBMins()
	local obbmax = self:OBBMaxs()
	
	local w, h = math.Round((math.abs(obbmax.y - obbmin.y) - 2) / Scale), math.Round((math.abs(obbmax.z - obbmin.z) - 2) / Scale); 
	
	obbmid.x = obbmid.x + 2.8
	
	obbmid.y = obbmid.y - (w * Scale * .5)
	obbmid.z = obbmid.z + (h * Scale * .5) 
	
	obbmin.z = obbmax.z - 1
	obbmin.y = obbmin.y + 1
	obbmin.x = obbmid.x;
	
	local pos2 = self:LocalToWorld(obbmin)
	local pos = self:LocalToWorld(obbmid)
	local ang = self:GetAngles()  
	
    ang:RotateAroundAxis(ang:Right(), -90); 
    ang:RotateAroundAxis(ang:Up(), 90);
	
	cam.Start3D2D(pos, ang, Scale);
		if (!tvRT) then
			surface.SetTexture(restartGMod)
			surface.SetDrawColor(255, 255, 255, 255)
			surface.DrawTexturedRect(0, 0, w, h)
		elseif (!GAMEMODE.Options_EnableTVs:GetBool()) then
			surface.SetTexture(enableTVs)
			surface.SetDrawColor(255, 255, 255, 255)
			surface.DrawTexturedRect(0, 0, w, h)
		elseif (GetGlobalInt("tv_status", 0) == 0) then
			// Weather
			
			surface.SetDrawColor(121, 156, 255, 255)
			surface.DrawRect(0, 0, w, h)
			
			local weatherID = 1
			if (GetGlobalInt("temp", 35) <= 32) then weatherID = 2 end
			local currentWeather = GetGlobalInt("clouds", CLOUDS_CLEAR)
			local futureWeather = GetGlobalInt("cloudsf", CLOUDS_CLEAR)
			
			surface.SetDrawColor(0, 0, 0, 255)
			local size = h / 4
			surface.DrawRect(75, 75, size + 4, size + 4)
			surface.SetDrawColor(255, 255, 255, 255)
			surface.SetTexture(weatherInformation[weatherID or 1][currentWeather or CLOUDS_CLEAR][1])
			surface.DrawTexturedRect(77, 77, size, size)
			
			draw.SimpleText("Currently " .. weatherInformation[weatherID or 1][currentWeather or CLOUDS_CLEAR][2], "TVLargeFont", 140 + size, 47 + size * 0.5, Color(0, 0, 0, 255));
			draw.SimpleText(GetGlobalInt("temp", 35) .. " Degrees Farhenheit", "TVLargeFont", 140 + size, 77 + size * 0.5, Color(0, 0, 0, 255));
			
			surface.SetDrawColor(0, 0, 0, 255)
			surface.DrawRect(75, 79 + size + 75, size + 4, size + 4)
			surface.SetDrawColor(255, 255, 255, 255)
			surface.SetTexture(weatherInformation[weatherID or 1][futureWeather or CLOUDS_CLEAR][1])
			surface.DrawTexturedRect(77, 79 + size + 77, size, size)
			
			draw.SimpleText("Later Today Expect " .. weatherInformation[weatherID or 1][futureWeather or CLOUDS_CLEAR][2], "TVLargeFont", 140 + size, 77 + size * 0.5 + 75 + size, Color(0, 0, 0, 255), nil, 1);
			
			if (currentWeather == CLOUDS_STORMY_SEVERE) then
				local txt = "Tornado Watch"
				if (weatherID == 2) then txt = "Blizzard Warning" end
				
				surface.SetDrawColor(255, 0, 0, 255)
				surface.DrawRect(0, h - size * 0.6, w, size * 0.6)
				draw.SimpleText("A " .. txt .. " Is In Effect", "TVLargeFont", w * 0.5, h - size * 0.4, Color(0, 0, 0, 255), TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
			end
		elseif (GetGlobalInt("tv_status", 0) == 1) then
			// Criminal Report
			
			
		end
	cam.End3D2D();
end

   
function ENT:IsTranslucent( ) 
	return true;
end
