///////////////////////////////
//  2009-2010 Pulsar Effect //
//    All rights reserved    //
///////////////////////////////
// This material may not be  //
//   reproduced, displayed,  //
//  modified or distributed  //
// without the express prior //
// written permission of the //
//   the copyright holder.   //
///////////////////////////////


// Include the shared init file.
include("sh_init.lua");

// Include the server files.
include("sv_config.lua");
include("sv_hooks.lua");
include("sv_networking.lua");
include("sv_player.lua");
include("sv_items.lua");
include("sv_skills.lua");
include("sv_misc.lua");
include("sv_chat.lua");
include("sv_organizations.lua");
include("sv_vehicles.lua");
include("sv_trade.lua");

GM.maxPlayers = 50

for k, v in pairs(file.FindInLua("PERP2.5/gamemode/sv_modules/*.lua")) do include("sv_modules/" .. v); end

// Add client lua resources.
AddCSLuaFile("cl_init.lua");
AddCSLuaFile("cl_player.lua");
AddCSLuaFile("cl_networking.lua");
AddCSLuaFile("cl_hooks.lua");
AddCSLuaFile("cl_misc.lua");
AddCSLuaFile("cl_items.lua");
AddCSLuaFile("cl_chat.lua");
AddCSLuaFile("cl_vehicles.lua");
AddCSLuaFile("cl_trade.lua");
AddCSLuaFile("cl_scoreboards.lua");

AddCSLuaFile("sh_init.lua");
AddCSLuaFile("sh_player.lua");
AddCSLuaFile("sh_items.lua");
AddCSLuaFile("sh_config.lua");
AddCSLuaFile("sh_npcs.lua");
AddCSLuaFile("sh_shops.lua");
AddCSLuaFile("sh_skills.lua");
AddCSLuaFile("sh_misc.lua");
AddCSLuaFile("sh_mixtures.lua");
AddCSLuaFile("sh_property.lua");
AddCSLuaFile("sh_vehicles.lua");

for k, v in pairs(file.FindInLua("PERP2.5/gamemode/cl_modules/*.lua")) do AddCSLuaFile("cl_modules/" .. v); end
for k, v in pairs(file.FindInLua("PERP2.5/gamemode/sh_modules/*.lua")) do AddCSLuaFile("sh_modules/" .. v); end
for k, v in pairs(file.FindInLua("PERP2.5/gamemode/vgui/*.lua")) do AddCSLuaFile("vgui/" .. v); end
for k, v in pairs(file.FindInLua("PERP2.5/gamemode/items/*.lua")) do AddCSLuaFile("items/" .. v); end
for k, v in pairs(file.FindInLua("PERP2.5/gamemode/npcs/*.lua")) do AddCSLuaFile("npcs/" .. v); end
for k, v in pairs(file.FindInLua("PERP2.5/gamemode/shops/*.lua")) do AddCSLuaFile("shops/" .. v); end
for k, v in pairs(file.FindInLua("PERP2.5/gamemode/mixtures/*.lua")) do AddCSLuaFile("mixtures/" .. v); end
for k, v in pairs(file.FindInLua("PERP2.5/gamemode/properties/*.lua")) do AddCSLuaFile("properties/" .. v); end
for k, v in pairs(file.FindInLua("PERP2.5/gamemode/vehicles/*.lua")) do AddCSLuaFile("vehicles/" .. v); end
for k, v in pairs(file.FindInLua("PERP2.5/gamemode/scoreboards/*.lua")) do AddCSLuaFile("scoreboards/" .. v); end

local ClientResources = 0;
local function ProcessFolder ( Location )
	for k, v in pairs(file.Find(Location .. '*')) do
		if file.IsDir(Location .. v) then
			ProcessFolder(Location .. v .. '/')
		else
			local OurLocation = string.gsub(Location .. v, '../gamemodes/PERP2.5/content/', '')
			
			if string.sub(Location, -2) != 'db' then			
				ClientResources = ClientResources + 1;
				resource.AddFile(OurLocation);
			end
		end
	end
end

if isDedicatedServer() then
	ProcessFolder('../gamemodes/PERP2.5/content/models/');
	ProcessFolder('../gamemodes/PERP2.5/content/materials/');
	ProcessFolder('../gamemodes/PERP2.5/content/sound/');
	ProcessFolder('../gamemodes/PERP2.5/content/resource/');
end

Msg("Sent " .. ClientResources .. " client resources.\n");
