///////////////////////////////
//  2009-2010 Pulsar Effect //
//    All rights reserved    //
///////////////////////////////
// This material may not be  //
//   reproduced, displayed,  //
//  modified or distributed  //
// without the express prior //
// written permission of the //
//   the copyright holder.   //
///////////////////////////////


local NPC = {};

NPC.Name = "Dealership";
NPC.ID = 14;

NPC.Model = Model("models/humans/suits2/male_04.mdl");
NPC.Invisible = false; // Used for ATM Machines, Casino Tables, etc.

NPC.Location = Vector(4518.593750, -4198.743652, 204.0313);
NPC.Angles = Angle(0, 45, 0);
NPC.ShowChatBubble = "VIP";

NPC.Sequence = 3;

// This is always local player.
function NPC.OnTalk ( )
	if (!LocalPlayer():IsVIP()) then
		GAMEMODE.DialogPanel:SetDialog("You don't seem to be a VIP. Sorry, I can't help you.");
		
		GAMEMODE.DialogPanel:AddDialog("How do I become a VIP?", NPC.HowVIP)
		GAMEMODE.DialogPanel:AddDialog("Fine, i'll go elsewhere.", LEAVE_DIALOG)
	else
		GAMEMODE.DialogPanel:SetDialog("Welcome to Big Bill Hell's used car dealership! I'm the one in charge of the VIP cars, how can I help you?");
		
		GAMEMODE.DialogPanel:AddDialog("Hey! I'm looking for a new car.", NPC.NewCar)
		GAMEMODE.DialogPanel:AddDialog("I seemed to lost my car. Have you seen it around?", NPC.LostCar)
		GAMEMODE.DialogPanel:AddDialog("You can't help me. Nobody can help me.", LEAVE_DIALOG)
	end;
	
	GAMEMODE.DialogPanel:Show();
end

function NPC.NewCar ( )
	GAMEMODE.DialogPanel:SetDialog("You've come to the right place! Let me show you around.");
	
	GAMEMODE.DialogPanel:AddDialog("Alright, show me your stock.", NPC.ShowCars)
	GAMEMODE.DialogPanel:AddDialog("Do you accept cash payments?", NPC.NoCash)
	GAMEMODE.DialogPanel:AddDialog("Ahh, I don't have time for this right now, sorry.", LEAVE_DIALOG)
end

function NPC.ShowCars ( )
	GAMEMODE.ShowVIPDealershipView();
	LEAVE_DIALOG();
end

function NPC.NoCash ( )
	GAMEMODE.DialogPanel:SetDialog("Sorry, we only accept direct bank transactions. Most people don't carry around enough money in their wallets, anyway.");

	GAMEMODE.DialogPanel:AddDialog("Alright, show me your stock.", NPC.ShowCars)
	GAMEMODE.DialogPanel:AddDialog("Ahh, I don't have time for this right now, sorry.", LEAVE_DIALOG)
end

function NPC.LostCar ( )
	GAMEMODE.DialogPanel:SetDialog("I haven't seen it, but have you checked the parking garage?\n\n(You can claim your previously purchased vehicles at the parking garage.)");

	GAMEMODE.DialogPanel:AddDialog("Oh yah, I remember now! Thanks!", LEAVE_DIALOG)
end

function NPC.HowVIP ( )
	GAMEMODE.DialogPanel:SetDialog("To become VIP, simply visit www.phoenixdawn.org and click the donate tab on the top. Our current prices are $10 for a month of VIP and $25 for a year of VIP.");

	GAMEMODE.DialogPanel:AddDialog("Oh yah, I remember now! Thanks!", LEAVE_DIALOG)
end

GAMEMODE:LoadNPC(NPC);