///////////////////////////////
//  2009-2010 Pulsar Effect //
//    All rights reserved    //
///////////////////////////////
// This material may not be  //
//   reproduced, displayed,  //
//  modified or distributed  //
// without the express prior //
// written permission of the //
//   the copyright holder.   //
///////////////////////////////


VEHICLE_DATABASE = {};

// Display order for garage.
VEHICLE_DISPLAY_ORDER = {"a", "n", "b", "c", "d", "e", "o", "f", "g", "s" , "q", "h", "t", "i", "r", "j", "p", "k", "l", "m"};
// Non-VIPS (Dealership)
VEHICLE_DISPLAY_ORDER_NORMAL = {"a", "n", "b", "c", "d", "e", "o", "f", "g", "q", "h", "i", "j", "p", "k", "l", "m"};
// VIPS (Dealership)
VEHICLE_DISPLAY_ORDER_VIP = {"s", "t", "r"};

function GM:RegisterVehicle ( VehicleTable )
	if (VEHICLE_DATABASE[VehicleTable.ID]) then
		Error("Conflicting vehicle ID's #" .. VehicleTable.ID);
	end
	
	if (CLIENT && !VehicleTable.RequiredClass) then
		VehicleTable.Texture = surface.GetTextureID('PERP2/vehicles/' .. VehicleTable.Script);
	end
	
	for k, v in pairs(VehicleTable.PaintJobs) do
		util.PrecacheModel(v.model);
	end
	
	VEHICLE_DATABASE[VehicleTable.ID] = VehicleTable;
	Msg("\t-> Loaded " .. VehicleTable.Name .. "\n");
end

function PLAYER:HasVehicle ( vehicleID )
	local playerTable;
	
	if SERVER then playerTable = self.Vehicles; else playerTable = GAMEMODE.Vehicles; end
	
	if (playerTable[vehicleID]) then return true; else return false; end
end

