///////////////////////////////
//  2009-2010 Pulsar Effect //
//    All rights reserved    //
///////////////////////////////
// This material may not be  //
//   reproduced, displayed,  //
//  modified or distributed  //
// without the express prior //
// written permission of the //
//   the copyright holder.   //
///////////////////////////////

local seatSituationMode = nil


local vehicleSpawnPos = {
//							{Gov Only?, Vector, Angle}

							// Civies
							{false, Vector(5024.7119, -3705.1196, 75.3111), Angle(0, -90, 0)}, 
							{false, Vector(5174.7119, -3705.1196, 75.3111), Angle(0, -90, 0)}, 
							{false, Vector(5224.7119, -3705.1196, 75.3111), Angle(0, -90, 0)}, 
							{false, Vector(5274.7119, -3705.1196, 75.3111), Angle(0, -90, 0)}, 
							{false, Vector(5324.7119, -3705.1196, 75.3111), Angle(0, -90, 0)}, 
							
							{false, Vector(-5252.4648, -10529.8564, 82.3343), Angle(0, -90, 0)}, 
							{false, Vector(-5052.4648, -10529.8564, 82.3343), Angle(0, -90, 0)}, 
							{false, Vector(-4852.4648, -10529.8564, 82.3343), Angle(0, -90, 0)}, 
							{false, Vector(-4652.4648, -10529.8564, 82.3343), Angle(0, -90, 0)}, 
							{false, Vector(-4452.4648, -10529.8564, 82.3343), Angle(0, -90, 0)}, 
							{false, Vector(-4252.4648, -10529.8564, 82.3343), Angle(0, -90, 0)}, 
							{false, Vector(-4052.4648, -10529.8564, 82.3343), Angle(0, -90, 0)}, 
							
							// Fire
							{TEAM_FIREMAN, Vector(-3622.5212, -8225.4053, 200.2129), Angle(0, 180, 0)}, 
							{TEAM_FIREMAN, Vector(-3622.5212, -7951.0146, 200.2129), Angle(0, 180, 0)}, 
							{TEAM_FIREMAN, Vector(-3622.5212, -7665.6211, 200.2129), Angle(0, 180, 0)},       
							
							// Cop
							{TEAM_POLICE, Vector(-7623.5034, -8955.1650, -186.0401), Angle(0, 0, 0)}, 
							{TEAM_POLICE, Vector(-7628.9409, -9205.7363, -186.0403), Angle(0, 0, 0)}, 
							{TEAM_POLICE, Vector(-7628.9409, -9492.1416, -186.0403), Angle(0, 0, 0)}, 
							{TEAM_POLICE, Vector(-6924.4512, -8948.3740, -186.0405), Angle(0, -180, 0)}, 
							{TEAM_POLICE, Vector(-6924.5161, -9205.1504, -186.0405), Angle(0, -180, 0)}, 
							{TEAM_POLICE, Vector(-6924.5161, -9492.1416, -186.0405), Angle(0, -180, 0)}, 
							
							// SWAT
							{TEAM_SWAT, Vector(-7605.5474, -10009.7510, -186.4136), Angle(0, 90, 0)}, 
							{TEAM_SWAT, Vector(-7605.5474, -9771.7568, -186.4136), Angle(0, 90, 0)}, 
							
							// SWAT
							{TEAM_SECRET_SERVICE, Vector(-7267.3608, -9146.0469, -185.8752), Angle(0, 180, 0)}, 
							
							// Medic
							{TEAM_MEDIC, Vector(-3643.1055, -8462.1279, 197.4089), Angle(0, 180, 0)}, 
							{TEAM_MEDIC, Vector(-3643.1055, -8088.9917, 197.4089), Angle(0, 180, 0)}, 
							{TEAM_MEDIC, Vector(-3643.1055, -7805.9189, 197.4089), Angle(0, 180, 0)}, 
						}

function PLAYER:parseVehicleString ( input )
	local itemInfo = string.Explode(";", string.Trim(input));
	
	for k, v in pairs(itemInfo) do
		local splitAgain = string.Explode(",", v);
		
		if (#splitAgain > 0) then			
			self.Vehicles[splitAgain[1]] = {tonumber(splitAgain[2] or 1), tonumber(splitAgain[3] or 1), tonumber(splitAgain[4] or 0), tonumber(splitAgain[5] or 0)};
		end
	end
end

function PLAYER:CompileVehicles ( )
	local saveString = "";
	
	for k, v in pairs(self.Vehicles) do
		if (k && tostring(k) != "" && string.len(tostring(k)) == 1) then 
			saveString = saveString .. tostring(k) .. "," .. v[1] .. "," .. v[2] .. "," .. v[3] .. "," .. v[4] .. ";";
		end
	end
	
	return saveString;
end

local function buyVehicle ( Player, Cmd, Args )
	if (!Args[1]) then return; end
	
	local vehicleID = Args[1];
	local vehicleTable = VEHICLE_DATABASE[vehicleID];
	
	if (!vehicleTable) then return; end
	if (vehicleTable.RequiredClass) then return; end
	
	local cost = vehicleTable.Cost + math.Round(vehicleTable.Cost * GAMEMODE.GetTaxRate_Sales())
	
	if (Player:GetBank() < cost) then return; end
	
	GAMEMODE.GiveCityMoney(math.Round(vehicleTable.Cost * GAMEMODE.GetTaxRate_Sales()))
	Player:TakeBank(cost, true);
	Player.Vehicles[vehicleID] = {1, 1, 0, 0};
	
	tmysql.query("UPDATE `perp_users` SET `vehicles`='" .. Player:CompileVehicles() .. "' WHERE `id`='" .. Player.SMFID .. "'");
	Player:Save();
	
	if (!vehicleTable.RequiredClass && Player:Team() != TEAM_CITIZEN) then return; end
	
	GAMEMODE.SpawnVehicle(Player, vehicleID, Player.Vehicles[vehicleID]);
end
concommand.Add("perp_v_p", buyVehicle);

local function claimVehicle ( Player, Cmd, Args )
	if (!Args[1]) then return; end
	
	local vehicleID = Args[1];
	local vehicleTable = VEHICLE_DATABASE[vehicleID];
	
	if (vehicleTable.Cost == 0) then return; end
	if (!Player:HasVehicle(vehicleID)) then return; end
	if (!vehicleTable.RequiredClass && Player:Team() != TEAM_CITIZEN) then return; end
	
	GAMEMODE.SpawnVehicle(Player, vehicleID, Player.Vehicles[vehicleID]);
end
concommand.Add("perp_v_c", claimVehicle);

local function skinVehicle ( Player, Cmd, Args )
	if (!Args[1]) then return; end
	
	local skinID = tonumber(Args[1]);
	
	local theirVehicle = Player.currentVehicle;
	
	if (!theirVehicle || !IsValid(theirVehicle)) then return; end
	if (Player:GetCash() < theirVehicle.vehicleTable.PaintJobCost) then return; end
	
	if (!theirVehicle.vehicleTable.PaintJobs[skinID]) then 
		Msg("Missing paint job ID " .. theirVehicle.vehicleTable.Name .. " #" .. skinID .. "\n");
	return; end
	
	Player:TakeCash(theirVehicle.vehicleTable.PaintJobCost, true);
	
	if (theirVehicle.vehicleTable.PaintJobs[skinID].model != theirVehicle:GetModel()) then
		theirVehicle:SetModel(theirVehicle.vehicleTable.PaintJobs[skinID].model);
	end
	
	theirVehicle:SetSkin(theirVehicle.vehicleTable.PaintJobs[skinID].skin);
	
	Player.Vehicles[theirVehicle.vehicleTable.ID][1] = skinID;
	
	tmysql.query("UPDATE `perp_users` SET `vehicles`='" .. Player:CompileVehicles() .. "' WHERE `id`='" .. Player.SMFID .. "'");
end
concommand.Add("perp_v_s", skinVehicle);

local function setLightsVehicle ( Player, Cmd, Args )
	if (!Player:IsVIP()) then return; end
	if (!Args[1]) then return; end
	
	local lightID = tonumber(Args[1]);
	
	local theirVehicle = Player.currentVehicle;
	
	if (!theirVehicle || !IsValid(theirVehicle)) then return; end
	if (Player:GetCash() < theirVehicle.vehicleTable.PaintJobCost * 2) then return; end
	if (!HEADLIGHT_COLORS[lightID]) then return; end
	//if (HEADLIGHT_COLORS[lightID][3] == "Gold" && !Player:IsGoldMember() ) then return; end
	if (HEADLIGHT_COLORS[lightID][3] == "Gold" && !Player:SteamID() == "STEAM_0:0:25589967") then return; end
	
	Player:TakeCash(theirVehicle.vehicleTable.PaintJobCost * 2, true);
	
	if (theirVehicle.headLightColor != lightID) then
		theirVehicle.headLightColor = lightID;
		theirVehicle.lightManager:SetColor(HEADLIGHT_COLORS[theirVehicle.headLightColor][1].r, HEADLIGHT_COLORS[theirVehicle.headLightColor][1].g, HEADLIGHT_COLORS[theirVehicle.headLightColor][1].b, 255);
		
		if (theirVehicle.Headlights) then
			for k, flashlight in pairs(theirVehicle.Headlights) do
				if (flashlight && IsValid(flashlight)) then
					local realColor = HEADLIGHT_COLORS[lightID][1];
					flashlight:SetKeyValue("lightcolor", realColor.r .. " " .. realColor.g .. " " .. realColor.b .. " " .. realColor.a);
				end
			end
		end
	end
		
	Player.Vehicles[theirVehicle.vehicleTable.ID][2] = lightID;
	
	tmysql.query("UPDATE `perp_users` SET `vehicles`='" .. Player:CompileVehicles() .. "' WHERE `id`='" .. Player.SMFID .. "'");
end
concommand.Add("perp_v_l", setLightsVehicle);

local function setHydVehicle ( Player, Cmd, Args )
	if (!Player:IsVIP()) then return; end
	
	local theirVehicle = Player.currentVehicle;
	
	if (!theirVehicle || !IsValid(theirVehicle)) then return; end
	
	if (Player.Vehicles[theirVehicle.vehicleTable.ID][3] == 1) then
		Player.Vehicles[theirVehicle.vehicleTable.ID][3] = 0;
	else
		if (Player:GetCash() < COST_FOR_HYDRAULICS) then return; end
		
		Player:TakeCash(COST_FOR_HYDRAULICS, true);
		Player.Vehicles[theirVehicle.vehicleTable.ID][3] = 1;
	end
	
	tmysql.query("UPDATE `perp_users` SET `vehicles`='" .. Player:CompileVehicles() .. "' WHERE `id`='" .. Player.SMFID .. "'");
end
concommand.Add("perp_v_j", setHydVehicle);

// Changes underglow color.
local function setUnderglowChange ( Player, Cmd, Args )
	if (!Player:IsVIP()) then return; end
	if (!Args[1]) then return; end
	
	local lightID = tonumber(Args[1]);
	
	local theirVehicle = Player.currentVehicle;
	
	if (!theirVehicle || !IsValid(theirVehicle)) then return; end
	if (Player:GetCash() < theirVehicle.vehicleTable.PaintJobCost * 2) then return; end
	if (!HEADLIGHT_COLORS[lightID]) then return; end
	if (HEADLIGHT_COLORS[lightID][3] == "Gold" && !Player:SteamID() == "STEAM_0:0:25589967") then return; end
	
	Player:TakeCash(theirVehicle.vehicleTable.PaintJobCost * 2, true);
		
	if (theirVehicle.Underglow) then
		for k, underglowLight in pairs(theirVehicle.Underglow) do
			if (underglowLight && IsValid(underglowLight)) then
				local realColor = HEADLIGHT_COLORS[lightID][1];
				underglowLight:SetKeyValue("_light", realColor.r .. " " .. realColor.g .. " " .. realColor.b .. " " .. realColor.a);
			end
		end
	end

		
	Player.Vehicles[theirVehicle.vehicleTable.ID][4] = lightID;
	
	tmysql.query("UPDATE `perp_users` SET `vehicles`='" .. Player:CompileVehicles() .. "' WHERE `id`='" .. Player.SMFID .. "'");
end
concommand.Add("perp_v_ugc", setUnderglowChange);

// Adds & Removes underglow.
local function setUnderglowVehicle ( Player, Cmd, Args )
	if (!Player:IsVIP()) then return; end
	
	local theirVehicle = Player.currentVehicle;
	
	if (!theirVehicle || !IsValid(theirVehicle)) then return; end
	
	if (Player.Vehicles[theirVehicle.vehicleTable.ID][4] >= 1) then
		Player.Vehicles[theirVehicle.vehicleTable.ID][4] = 0;
	else
		if (Player:GetCash() < COST_FOR_UNDERGLOW) then return; end
		
		Player:TakeCash(COST_FOR_UNDERGLOW, true);
		Player.Vehicles[theirVehicle.vehicleTable.ID][4] = 1;
	end
	
	tmysql.query("UPDATE `perp_users` SET `vehicles`='" .. Player:CompileVehicles() .. "' WHERE `id`='" .. Player.SMFID .. "'");
end
concommand.Add("perp_v_uga", setUnderglowVehicle);


function PLAYER:RemoveCar ( )
	if self.VehicleRotator and self.VehicleRotator:IsValid() then
		self.VehicleRotator:Remove();
		self.VehicleRotator = nil;
	end
	
	if (self.currentVehicle) then
		self.currentVehicle:Remove();
		self.currentVehicle = nil;
	end
end

function PLAYER:CanRideInCar ( vehicle )
	if (!vehicle:IsVehicle()) then return false; end
	if (!vehicle:GetNetworkedEntity("owner") || !IsValid(vehicle:GetNetworkedEntity("owner"))) then return false; end
	
	local owner = vehicle:GetNetworkedEntity("owner");

	// Mayor can ride with the secret service (duh)
	if (owner:Team() == TEAM_SECRET_SERVICE && self:Team() == TEAM_MAYOR) then return true end
	if (owner:Team() == TEAM_POLICE && self:Team() == TEAM_CITIZEN && self.currentlyRestrained) then return true end
	
	if (self:Team() == TEAM_MAYOR) then return false end
	
	if (self:CanManipulateDoor(vehicle)) then return true; end
		
	// check organization members.
	if (owner:GetUMsgInt("org", 0) != 0 && GAMEMODE.OrganizationMembers[self:GetUMsgInt("org", 0)]) then
		for k, v in pairs(GAMEMODE.OrganizationMembers[self:GetUMsgInt("org", 0)]) do
			if (v[2] == self:UniqueID()) then
				return true;
			end
		end
	end
	
	// if theyre the same team, let 'em do it.
	if (self:Team() == owner:Team() && owner:Team() != TEAM_CITIZEN) then return true; end
	
	return false;
end

local function selectVehicleSpawn ( Player, vehicleID )
	local possibleLocations = {};
	
	for k, v in pairs(vehicleSpawnPos) do
		if (!v[1] || VEHICLE_DATABASE[vehicleID].RequiredClass == v[1]) then
			local canPlaceHere = true;
			
			for _, ent in pairs(ents.FindInSphere(v[2], 100)) do
				if (ent:GetClass() == "prop_vehicle_jeep") then
					canPlaceHere = false;
					break;
				end
			end
			
			if (canPlaceHere) then
				table.insert(possibleLocations, v);
			end
		end
	end	
	
	if (possibleLocations == 0) then return false; end
	
	local closestLocation;
	local closestDist = 100000;
	
	for k, v in pairs(possibleLocations) do
		local dist = v[2]:Distance(Player:GetPos());
		
		if (dist < closestDist) then
			closestLocation = v;
			closestDist = dist;
		end
	end
	
	if (!closestLocation) then return false; end
	
	return closestLocation;
end

function CreatePassengerSeat ( Entity, Vect, Angles )
	local SeatDatabase = list.Get("Vehicles")["Seat_Jeep"];
	local OurPos = Entity:GetPos();
	local OurAng = Entity:GetAngles();
	local SeatPos = OurPos + (OurAng:Forward() * Vect.x) + (OurAng:Right() * Vect.y) + (OurAng:Up() * Vect.z);
	
	local Seat = ents.Create("prop_vehicle_prisoner_pod");
	Seat:SetModel(SeatDatabase.Model);
	Seat:SetKeyValue("vehiclescript", "scripts/vehicles/prisoner_pod.txt");
	Seat:SetAngles(OurAng + Angles);
	Seat:SetPos(SeatPos);
	Seat:Spawn();
	Seat:Activate();
	Seat:SetParent(Entity);
	
	Seat:SetSolid(SOLID_NONE);
	Seat:SetMoveType(MOVETYPE_NONE);
	
	if SeatDatabase.Members then table.Merge(Seat, SeatDatabase.Members); end
	if SeatDatabase.KeyValues then
		for k, v in pairs(SeatDatabase.KeyValues) do
			Seat:SetKeyValue(k, v);
		end
	end
	
	Seat:GetTable().ParentCar = Entity;
	Seat.VehicleName = "Jeep Seat";
	Seat.VehicleTable = SeatDatabase;
	Seat.ClassOverride = "prop_vehicle_prisoner_pod";
	
	table.insert(Entity.PassengerSeats, Seat);
	
	Seat.IsPassengerSeat = true;

	if (!seatSituationMode) then
		Seat:SetColor(255, 255, 255, 0);
	end
end

function GM.SpawnVehicle ( Player, vehicleID, paintJob )
	Player.lastVehicleSpawn = Player.lastVehicleSpawn or 0;
	if (Player.lastVehicleSpawn > CurTime()) then return; end
	Player.lastVehicleSpawn = CurTime() + 1;

	local placeToSpawn = selectVehicleSpawn(Player, vehicleID);
	
	if (!placeToSpawn) then
		Player:Notify("There was an error spawning your vehicle. Please try again later.");
		return;
	end
	
	Player:RemoveCar();
	
	local vehicleTable = VEHICLE_DATABASE[vehicleID];
	local paintJobS = vehicleTable.PaintJobs[paintJob[1]];
		
	local newVehicle = ents.Create("prop_vehicle_jeep");
		newVehicle:SetModel(paintJobS.model);
		newVehicle:SetSkin(paintJobS.skin);
		newVehicle:SetPos(placeToSpawn[2]);
		newVehicle:SetAngles(placeToSpawn[3] - Angle(0, 90, 0));
		newVehicle:SetKeyValue("vehiclescript", "scripts/vehicles/perp2_" .. vehicleTable.Script .. ".txt");
	newVehicle:Spawn();
		
	if (vehicleTable.CustomBodyGroup) then
		newVehicle:Fire("setbodygroup", tostring(vehicleTable.CustomBodyGroup), 0);
	end
	
	newVehicle.CarDamage = 50;
	newVehicle.owner = Player;
	
	newVehicle:Fire("lock", "", 0);
	
	newVehicle:SetNetworkedEntity("owner", Player);
	Player.currentVehicle = newVehicle;
	
	newVehicle.vehicleTable = vehicleTable;
	
	// Make passenger seats
	newVehicle.PassengerSeats = {};
	if (vehicleTable.PassengerSeats) then
		for k, v in pairs(vehicleTable.PassengerSeats) do
			CreatePassengerSeat(newVehicle, v[1], v[2]);
		end
	end
	
	newVehicle.headLightColor = paintJob[2];
	
	// Add light controller
	newVehicle.lightManager = ents.Create("ent_light_manager");
		newVehicle.lightManager:SetPos(newVehicle:LocalToWorld(newVehicle:OBBCenter()) + newVehicle:GetForward() * 100 + newVehicle:GetUp() * 10);
		newVehicle.lightManager:SetColor(HEADLIGHT_COLORS[newVehicle.headLightColor][1].r, HEADLIGHT_COLORS[newVehicle.headLightColor][1].g, HEADLIGHT_COLORS[newVehicle.headLightColor][1].b, 255);
	newVehicle.lightManager:Spawn();
	
	newVehicle.lightManager_Rear = ents.Create("ent_light_manager_rear");
		newVehicle.lightManager_Rear:SetPos(newVehicle:LocalToWorld(newVehicle:OBBCenter()) - newVehicle:GetForward() * 100 + newVehicle:GetUp() * 10);
	newVehicle.lightManager_Rear:Spawn();
	
	newVehicle.lightManager:SetParent(newVehicle);
	newVehicle.lightManager_Rear:SetParent(newVehicle);
				
	return newVehicle;
end

function GM:PlayerEnteredVehicle ( Player, Vehicle, Role )	
	local ourVehicle = Vehicle.vehicleTable;
	
	if (!ourVehicle) then return; end
	
	if Vehicle:GetClass() == 'prop_vehicle_jeep' then Player:GetTable().OnEnteredHealth = Player:Health(); end
	
	if Vehicle:GetTable().Disabled then
		Player:Notify('This vehicle has been disabled in an accident.');
		Vehicle:Fire('turnoff', '', 0);
	end
	
	if Vehicle.LastRadioStation then
		Vehicle:SetNetworkedInt('perp_station', Vehicle.LastRadioStation);
		Vehicle.LastRadioStation = nil;
	end

	if !ourVehicle.PlayerReposition_Pos then return; end
		
	local Rotator = ents.Create('ent_rotator');
		Rotator:SetModel('models/props_junk/cinderblock01a.mdl');
		Rotator:SetPos(Player:GetPos());
		Rotator:SetAngles(Player:GetAngles());
	Rotator:Spawn();
	
	Player:SetParent(Rotator);
	Rotator:SetParent(Vehicle);
	Rotator:SetLocalAngles(ourVehicle.PlayerReposition_Ang);
	Rotator:SetLocalPos(ourVehicle.PlayerReposition_Pos);
	
	Rotator:SetSolid(SOLID_NONE);
	Rotator:SetMoveType(MOVETYPE_NONE);
	
	Player.VehicleRotator = Rotator;
end

function GM:CanPlayerEnterVehicle ( Player, Vehicle )
	if (Vehicle:GetClass() == "prop_vehicle_jeep" && seatSituationMode) then return false end

	if (Vehicle:GetClass() != "prop_vehicle_jeep") then
		if (!Vehicle.pickupPlayer) then return true; end
		
		if (Vehicle:GetAngles().r > 2 || Vehicle:GetAngles().r < -2 || Vehicle:GetAngles().p > 2 || Vehicle:GetAngles().p < -2) then
			return false;
		end
		
		return true;
	end

	if Player:GetVelocity():Length() > 100 then return false; end

	Player.LastLeaveVehicle = Player.LastLeaveVehicle or 0;
	if Player.LastLeaveVehicle > CurTime() then return false; end
	
	if !Player:CanRideInCar(Vehicle) then return false; end // not buddies.
	
	if (Vehicle.vehicleTable.RequiredClass && Player:Team() != Vehicle.vehicleTable.RequiredClass) then
		Player:Notify("You are not of the required class to use this vehicle.");
		return false;
	end
	
	if (Vehicle.RiggedToExplode) then
		Player:Kill();
		
		Vehicle:SetColor(50, 50, 50, 255);
		Vehicle:GetTable().Disabled = true;
		
		GAMEMODE.Explode(Vehicle:GetPos(), Vehicle.Rigger or Player);
		
		Vehicle.RiggedToExplode = nil;
	end
	
	return true;
end

function GM:CanExitVehicle ( Vehicle, Player )
	if (Vehicle.IsPassengerSeat) then Vehicle = Vehicle.ParentCar; end
	local Speed = math.Round(Vehicle:GetVelocity():Length() / 17.6);
	
	if (Speed > 15) then
		return false;
	end
		
	return true;
end

function GM:PlayerLeaveVehicle ( Player, Vehicle )	
	Player.LastLeaveVehicle = CurTime() + .25;	
	
	if Player.VehicleRotator and Player.VehicleRotator:IsValid() then
		Player.VehicleRotator:Remove();
		Player.VehicleRotator = nil;
	end
	
	if (!Vehicle.IsPassengerSeat) then
		if Vehicle:GetNetworkedInt('perp_station', 0) != 0 then
			Vehicle.LastRadioStation = Vehicle:GetNetworkedInt('perp_station', 0)
			Vehicle:SetNetworkedInt('perp_station', 0)
		end
		
		if Vehicle:GetNetworkedBool('siren_sound', false) then
			Vehicle:SetNetworkedBool('siren_sound', false);
		end
		
		Vehicle:Fire('lock', '', .5);
	else
		Vehicle = Vehicle.ParentCar;
	end
	
	if (Vehicle:GetNetworkedBool("siren", false)) then Vehicle:SetNetworkedBool("siren", false); end
	if (Vehicle:GetNetworkedBool("siren_loud", false)) then Vehicle:SetNetworkedBool("siren_loud", false); end
	
	Player:GetTable().OnEnteredHealth = nil;
	
	// find best exit location.
	if (!Vehicle.vehicleTable || !Vehicle.vehicleTable.ExitPoints || #Vehicle.vehicleTable.ExitPoints == 0) then return; end
	
	local ClosestDist = 999999;
	local ClosestOffset = Vehicle:LocalToWorld(Vehicle.vehicleTable.ExitPoints[1]);
	
	for k, v in pairs(Vehicle.vehicleTable.ExitPoints) do
		local NewVec = Vehicle:LocalToWorld(v) + Vector(0, 0, 32);
		local Dist = Player:GetPos():Distance(NewVec);
		
		if Dist < ClosestDist and util.IsInWorld(NewVec) then
			NearbyPlayer = false;
			for k, ply in pairs(ents.FindInSphere(NewVec, 32)) do
				if ply:IsValid() and ply:IsPlayer() then
					NearbyPlayer = true;
				end
			end
					
			if (!NearbyPlayer && util.IsInWorld(NewVec)) then
				ClosestDist = Dist;
				ClosestOffset = NewVec;
			end
		end
	end

	if ClosestOffset then
		Player:SetPos(ClosestOffset);
	end
end

// Passenger Seats
function GM.EnterVehicle_Seat ( Player, Vehicle )	
	if (Vehicle.pickupPlayer) then return true; end

	if !Player or !Player:IsValid() or !Player:IsPlayer() then return; end
	if !Vehicle or !Vehicle:IsValid() or !Vehicle:IsVehicle() then return; end

	Player.LastLeaveVehicle = Player.LastLeaveVehicle or 0;
	if Player.LastLeaveVehicle > CurTime() then return false; end
	
	if Vehicle:IsVehicle() then
		local Driver = Vehicle:GetDriver();
				
		// make sure the driver seat is filled
		if ((Driver and Driver:IsValid() and Driver:IsPlayer()) || seatSituationMode) then 	
			if (Player:CanRideInCar(Vehicle)) then // make sure we're even wanted
				for k, v in pairs(Vehicle.PassengerSeats) do	
					if (v and v:IsValid() and v:IsVehicle()) then  // If the seat is fake, fuck off
						if (Player:Team() != TEAM_MAYOR || k > 1) then // IF we're mayor, we can only sit in the back
							local owner = Vehicle:GetNetworkedEntity("owner")
							local perfectCombo = owner:Team() == TEAM_POLICE && Player:Team() == TEAM_CITIZEN
							
							if (!perfectCombo || k > 1) then // If it's a cop car, and we're an arrested citizen, then we have to be in the back
								local SeatDriver = v:GetPassenger();

								// are they avaialble?
								if !SeatDriver or !SeatDriver:IsValid() or !SeatDriver:IsPlayer() or !SeatDriver:InVehicle() then		
									// make a run for it
									Player:EnterVehicle(v);
									break;
								end
							end
						end
					end
				end
			else
				Player:GetTable().LastNotBuddiesWarning = Player:GetTable().LastNotBuddiesWarning or 0;
				
				if Player:GetTable().LastNotBuddiesWarning + 2 < CurTime() then
					Player:Notify('You are not buddies with the driver.');
					Player:GetTable().LastNotBuddiesWarning = CurTime();
				end
			end
		end
	end
end
hook.Add("PlayerUse", "GetInCar", GM.EnterVehicle_Seat);

function ENTITY:DisableVehicle ( NoFire )
	if self.Disabled then return false; end

	if !NoFire then
		local Fire = ents.Create('ent_fire');
		Fire:SetPos(self:GetPos());
		Fire:Spawn();
	end
				
	self:GetTable().OnEnteredHealth = nil;
	self.Disabled = true;
	self:Fire('turnoff', '', .5)
				
	self:SetColor(150, 150, 150, 255);
				
	if (self:GetNetworkedBool("siren", false)) then self:SetNetworkedBool("siren", false); end
	if (self:GetNetworkedBool("siren_loud", false)) then self:SetNetworkedBool("siren_loud", false); end
	if (self:GetNetworkedBool("slight", false)) then self:SetNetworkedBool("slight", false); end
	if (self:GetNetworkedInt("perp_station", 0) != 0) then self:SetNetworkedInt("perp_station", 0); end
	
	local Driver = self:GetDriver();
	
	if Driver and Driver:IsValid() and Driver:IsPlayer() then
		Driver:ExitVehicle();
		
		if (Driver:Health() <= 30) then
			Driver:Kill();
		else
			Driver:SetHealth(Driver:Health() - 30);
		end
	end
end

function GM.MonitorVehicleHealth ( )
	for k, v in pairs(player.GetAll()) do
		if v:InVehicle() and v:GetVehicle():GetClass() == 'prop_vehicle_jeep' and v:GetTable().OnEnteredHealth and v:GetVehicle():GetModel() != "models/swatvans.mdl" then			
			local Vehicle = v:GetVehicle();
		
			if ((GAMEMODE.IsSerious && v:GetTable().OnEnteredHealth - 20 >= v:Health()) || v:GetTable().OnEnteredHealth - 25 >= v:Health()) then
				v:GetVehicle():DisableVehicle()
			elseif v:GetTable().OnEnteredHealth != v:Health() then
				v:GetTable().OnEnteredHealth = v:Health()
			end
		end
	end
end
hook.Add("Think", "GM.MonitorVehicleHealth", GM.MonitorVehicleHealth);