///////////////////////////////
//  2009-2010 Pulsar Effect //
//    All rights reserved    //
///////////////////////////////
// This material may not be  //
//   reproduced, displayed,  //
//  modified or distributed  //
// without the express prior //
// written permission of the //
//   the copyright holder.   //
///////////////////////////////


local PANEL = {};

surface.CreateFont("Tahoma", ScreenScale(6), 1000, true, false, "MixturesInfoFont") 
local WarningTexture = surface.GetTextureID("PERP2/warning");

function PANEL:Init ( )

end

function PANEL:PerformLayout ( )
	surface.SetFont("MixturesWarningFont");
	self.MainX, self.MainY = surface.GetTextSize("whatever.");
	self:SetHeight(self.MainY * 3);
	
	surface.SetFont("MixturesInfoFont");
	self.MinX, self.MinY = surface.GetTextSize("whatever.");
	
	if (self.ModelPanel) then
		self.ModelPanel:SetPos(9, 9);
		self.ModelPanel:SetSize(self:GetTall() - 18, self:GetTall() - 18);
	end
end

local unOccupied = surface.GetTextureID("PERP2/inventory/inv_empty");
function PANEL:Paint ( )
	draw.RoundedBox(4, 0, 0, self:GetWide(), self:GetTall(), SKIN.control_color);
	
	surface.SetDrawColor(0, 0, 0, 230);
	surface.DrawOutlinedRect(4, 4, self:GetTall() - 8, self:GetTall() - 8)
	surface.SetDrawColor(255, 255, 255, 230);
	surface.SetTexture(unOccupied);
	surface.DrawTexturedRect(5, 5, self:GetTall() - 10, self:GetTall() - 10)
	
	draw.SimpleText(self.Mixture.Name, "MixturesWarningFont", self:GetTall() + 10, 5, Color(255, 255, 255, 255), 0, 0);
	draw.SimpleText(self.requiresText, "MixturesInfoFont", self:GetTall() + 10, 8 + self.MainY, Color(255, 255, 255, 255), 0, 0);
	draw.SimpleText(self.requiredSkillsText, "MixturesInfoFont", self:GetTall() + 10, 8 + self.MainY + self.MinY, Color(255, 255, 255, 255), 0, 0);
end

function PANEL:SetMixture ( mID )
	self.Mixture = mID;
	
	self.requiresText = "Required Items: ";
	
	if (self.Mixture.RequiresHeatSource) then
		self.requiresText = self.requiresText .. "Heat Source, ";
	end
	
	if (self.Mixture.RequiresSawHorse) then
		self.requiresText = self.requiresText .. "Saw Horse, ";
	end
	
	if (self.Mixture.RequiresWaterSource) then
		self.requiresText = self.requiresText .. "Water Source, ";
	end
	
	local realTable = {};
	for k, v in pairs(self.Mixture.Ingredients) do
		realTable[v] = realTable[v] or 0;
		realTable[v] = realTable[v] + 1;
	end
	
	local num = 0;
	for k, v in pairs(realTable) do
		num = num + 1;
		self.requiresText = self.requiresText .. ITEM_DATABASE[k].Name .. " x " .. v;
		
		if (num != table.Count(realTable)) then
			self.requiresText = self.requiresText .. ", ";
		end
	end
	
	self.requiredSkillsText = "Required Skills: ";
	for k, v in pairs(self.Mixture.Requires) do
		self.requiredSkillsText = self.requiredSkillsText .. GAMEMODE.GetRealName(v[1]) .. " level " .. v[2];
		
		if (k != #self.Mixture.Requires) then
			self.requiredSkillsText = self.requiredSkillsText .. ", ";
		end
	end
	
	local itemTable = ITEM_DATABASE[self.Mixture.Results];
	
	self.ModelPanel = vgui.Create("DModelPanel", self);
	self.ModelPanel:SetModel(itemTable.InventoryModel);
	
	self.ModelPanel:SetCamPos(itemTable.ModelCamPos)
	self.ModelPanel:SetLookAt(itemTable.ModelLookAt)
	self.ModelPanel:SetFOV(itemTable.ModelFOV)
	
	local iSeq = self.ModelPanel.Entity:LookupSequence('ragdoll');
	self.ModelPanel.Entity:ResetSequence(iSeq);
	
	self.ModelPanel:SetPos(9, 9);
	self.ModelPanel:SetSize(self:GetTall() - 18, self:GetTall() - 18);
	function self.ModelPanel:LayoutEntity ( ) end
	
	return self;
end

vgui.Register('perp2_mixtures_info', PANEL);